/* jslib.c - Routines to manage the library specific aspects
 *
 * Copyright 1994 by Ulisses Pinto & Jose' Joa~o Almeida, Universidade do Minho
 *
 */

#include <string.h>

#include "config.h"
#include "jspell.h"
#include "proto.h"

hash_info pers,   /* personal dictionary */
          repl;   /* replacement "dic", can't be static */ 

struct genflagent gentable[MASKBITS];    /* CHANGE NEW */

void copy_array();
void copy_array2();

/*---------------------------------------------------------------------------*/

char *advance_beg(char *buf)
{
   char hadlf;
   int len;

   currentchar = buf;
   len = strlen(currentchar) - 1;
   hadlf = currentchar[len] == '\n';
   if (hadlf)
      currentchar[len] = 0;

   skip_ntroff_text_formaters(hadlf, stdout);/* stdout shouldn't be necessary */
   return(skiptoword(currentchar));
}

char *get_next_word(char *buf, char *next_word)
{
   char *word_ini, *word_end, *p;
   int i;

   word_ini = advance_beg(buf);
   if (*word_ini) {   /* there is in fact a word */
      word_end = skipoverword(word_ini);

      i = 0;
      p = word_ini;
      while (p != word_end) {
         next_word[i] = *p;
         i++;
         p++;
      }
      next_word[i] = '\0';
   }
   else word_end = NULL;
   return(word_end);
}

/*---------------------------------------------------------------------------*/

word_info(char *word, char solutions[MAXPOSSIBLE][MAXSOLLEN],
                      char near_misses[MAXPOSSIBLE][MAXSOLLEN])
/* solutions should already be allocated in the calling module */
{
   int old_cflag, old_lflag;

   old_cflag = cflag;
   old_lflag = lflag;
   cflag = 0;
   lflag = 0;
   strcpy(contextbufs[0], word);

   checkline(stdout);

   copy_array(solutions, sol_out);
   copy_array(near_misses, misses_out);

   cflag = old_cflag;
   lflag = old_lflag;
}


/*---------------------------------------------------------------------------*/

void insert_word(char *word, char *class, char *flags, char *comm)
{
   char fg, aux[MAXSOLLEN];

   fg = hashheader.flagmarker;
   sprintf(aux, "%s%c%s%c%s%c%s", word, fg, class, fg, flags, fg, comm);
   treeinsert(aux, ICHARTOSSTR_SIZE, 1);
}

/*---------------------------------------------------------------------------*/

void accept_word(char *word, char *class, char *flags, char *comm)
{
   char fg, aux[MAXSOLLEN];

   fg = hashheader.flagmarker;
   sprintf(aux, "%s%c%s%c%s%c%s", word, fg, class, fg, flags, fg, comm);
   treeinsert(aux, ICHARTOSSTR_SIZE, 0);
}

/*---------------------------------------------------------------------------*/

/*replace_word(char *start, char *word, char **curchar)*/
char* replace_word(char *start, char *word, char *curchar)
{
   char *word_ini;
   char *aux = curchar;
   char saux[SET_SIZE + MAXSTRINGCHARS];

   strcpy(saux,word);
   word_ini = advance_beg(start);
   replace_token(word_ini, word_ini, saux, &aux);
   return aux;
}
